/// <reference types="react" />
import PropTypes from 'prop-types';
import { formatShortWeekday as defaultFormatShortWeekday, formatWeekday as defaultFormatWeekday } from '../shared/dateFormatter';
import type { CalendarType } from '../shared/types';
type WeekdaysProps = {
    calendarType: CalendarType;
    formatShortWeekday?: typeof defaultFormatShortWeekday;
    formatWeekday?: typeof defaultFormatWeekday;
    locale?: string;
    onMouseLeave?: () => void;
};
declare function Weekdays(props: WeekdaysProps): JSX.Element;
declare namespace Weekdays {
    var propTypes: {
        calendarType: PropTypes.Requireable<"Arabic" | "Hebrew" | "ISO 8601" | "US">;
        formatShortWeekday: PropTypes.Requireable<(...args: any[]) => any>;
        formatWeekday: PropTypes.Requireable<(...args: any[]) => any>;
        locale: PropTypes.Requireable<string>;
        onMouseLeave: PropTypes.Requireable<(...args: any[]) => any>;
    };
}
export default Weekdays;
